/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer(s): Michel-Ange ANTON
 * --------------------------------------------------------------------------
 * $Id: DatasourcePropertiesForm.java,v 1.3 2003/06/20 17:15:41 antonma Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.resource;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

import org.objectweb.jonas.webapp.jonasadmin.Jlists;

public class DatasourcePropertiesForm extends ActionForm {

// --------------------------------------------------------- Constants

// --------------------------------------------------------- Properties variables

    /*
        #set ( $val = $datasourceProperties.getProperty("datasource.name", "") )
        #set ( $val = $datasourceProperties.getProperty("datasource.description", "") )
        #set ( $val = $datasourceProperties.getProperty("datasource.url", "") )
        #set ( $val = $datasourceProperties.getProperty("datasource.classname", "") )
        #set ( $val = $datasourceProperties.getProperty("datasource.username", "") )
        #set ( $val = $datasourceProperties.getProperty("datasource.password", "") )
        #set ( $val = $datasourceProperties.getProperty("datasource.factory", "none") )
        #set ( $val = $datasourceProperties.getProperty("datasource.mapper", "") )
        #set ( $val = $datasourceProperties.getProperty("datasource.connmaxage", "30") )
        #set ( $val = $datasourceProperties.getProperty("datasource.connchecklevel", "0") )
        #set ( $val = $datasourceProperties.getProperty("datasource.connteststmt", "SELECT 1") )
        #set ( $val = $datasourceProperties.getProperty("datasource.minconpool", "0") )
         #set ( $val = $datasourceProperties.getProperty("datasource.maxconpool", "no max boundary") )
     */
    private String name = null;
    private String datasourceName = null;
    private String datasourceDescription = null;
    private String datasourceUrl = null;
    private String datasourceClassname = null;
    private String datasourceUsername = null;
    private String datasourcePassword = null;
    private String datasourceFactory = null;
//   private String datasourceXadataname = null;
//   private String datasourceIsolationlevel = null;
    private String datasourceMapper = null;
    private String jdbcConnteststmt = null;
//   private String datasourceMaxcon = null;
//   private String datasourceMincon = null;
    private String jdbcConnchecklevel = null;
//   private String jdbcConnexcltimeout = null;
    private String jdbcConnmaxage = null;
//   private String jdbcConnmaxthreads = null;
//   private String jdbcDeadlockpool = null;
//   private String jdbcGenerationpool = null;
//   private String jdbcLoopwaitpool = null;
    private String jdbcMaxconpool = null;
    private String jdbcMinconpool = null;
//   private String jdbcSleeptimepool = null;
//   private boolean jdbcGcpool = false;

    private java.util.List booleanValues = Jlists.getBooleanValues();
    private java.util.List checkingLevels = Jlists.getJdbcConnectionCheckingLevels();
    private boolean create = true;

// --------------------------------------------------------- Public Methods

    /**
     * Reset all properties to their default values.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */

    public void reset(ActionMapping mapping, HttpServletRequest request) {
        // datas
        name = null;
        datasourceName = null;
        datasourceDescription = null;
        datasourceUrl = null;
        datasourceClassname = null;
        datasourceUsername = null;
        datasourcePassword = null;
        datasourceFactory = null;
//      datasourceXadataname = null;
//      datasourceMincon = "5";
//      datasourceMaxcon = "10";
//      datasourceIsolationlevel = null;
        datasourceMapper = null;
        jdbcConnmaxage = "30";
        jdbcConnchecklevel = "1";
        jdbcConnteststmt = "SELECT 1";
//      jdbcConnexcltimeout = "30";
//      jdbcConnmaxthreads = "4";
        jdbcMinconpool = "0";
        jdbcMaxconpool = "-1";
//      jdbcSleeptimepool = "300000";
//      jdbcGcpool = false;
//      jdbcGenerationpool = "1";
//      jdbcDeadlockpool = "300000";
//      jdbcLoopwaitpool = "10000";
    }

    /**
     * Validate the properties that have been set from this HTTP request,
     * and return an <code>ActionErrors</code> object that encapsulates any
     * validation errors that have been found.  If no errors are found, return
     * <code>null</code> or an <code>ActionErrors</code> object with no
     * recorded error messages.
     *
     * @param mapping The mapping used to select this instance
     * @param request The servlet request we are processing
     */
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        ActionErrors oErrors = new ActionErrors();
        if ((name == null) || (name.length() == 0)) {
            oErrors.add("name"
                , new ActionError("error.resource.datasource.properties.name.required"));
        }
        if ((datasourceName == null) || (datasourceName.length() == 0)) {
            oErrors.add("datasourceName"
                , new ActionError("error.resource.datasource.properties.datasourceName.required"));
        }
//      validateInteger(oErrors, datasourceMincon, "datasourceMincon"
//         , "error.resource.datasource.properties.datasourceMincon.numberformat");
//      validateInteger(oErrors, datasourceMaxcon, "datasourceMaxcon"
//         , "error.resource.datasource.properties.datasourceMaxcon.numberformat");
        validateInteger(oErrors, jdbcConnmaxage, "jdbcConnmaxage"
            , "error.resource.datasource.properties.jdbcConnmaxage.numberformat");
//      validateInteger(oErrors, jdbcConnexcltimeout, "jdbcConnexcltimeout"
//         , "error.resource.datasource.properties.jdbcConnexcltimeout.numberformat");
//      validateInteger(oErrors, jdbcConnmaxthreads, "jdbcConnmaxthreads"
//         , "error.resource.datasource.properties.jdbcConnmaxthreads.numberformat");
        validateInteger(oErrors, jdbcMinconpool, "jdbcMinconpool"
            , "error.resource.datasource.properties.jdbcMinconpool.numberformat");
        validateInteger(oErrors, jdbcMaxconpool, "jdbcMaxconpool"
            , "error.resource.datasource.properties.jdbcMaxconpool.numberformat");
//      validateInteger(oErrors, jdbcSleeptimepool, "jdbcSleeptimepool"
//         , "error.resource.datasource.properties.jdbcSleeptimepool.numberformat");
//      validateInteger(oErrors, jdbcGenerationpool, "jdbcGenerationpool"
//         , "error.resource.datasource.properties.jdbcGenerationpool.numberformat");
//      validateInteger(oErrors, jdbcDeadlockpool, "jdbcDeadlockpool"
//         , "error.resource.datasource.properties.jdbcDeadlockpool.numberformat");
//      validateInteger(oErrors, jdbcLoopwaitpool, "jdbcLoopwaitpool"
//         , "error.resource.datasource.properties.jdbcLoopwaitpool.numberformat");

        return oErrors;
    }

    protected void validateInteger(ActionErrors p_Errors, String p_Value, String p_Tag
        , String p_ResError) {
        try {
            Integer.parseInt(p_Value);
        }
        catch (NumberFormatException e) {
            p_Errors.add(p_Tag, new ActionError(p_ResError));
        }
    }

// --------------------------------------------------------- Properties Methods

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDatasourceName() {
        return datasourceName;
    }

    public void setDatasourceName(String datasourceName) {
        this.datasourceName = datasourceName;
    }

    public String getDatasourceDescription() {
        return datasourceDescription;
    }

    public void setDatasourceDescription(String datasourceDescription) {
        this.datasourceDescription = datasourceDescription;
    }

    public String getDatasourceUrl() {
        return datasourceUrl;
    }

    public void setDatasourceUrl(String datasourceUrl) {
        this.datasourceUrl = datasourceUrl;
    }

    public String getDatasourceClassname() {
        return datasourceClassname;
    }

    public void setDatasourceClassname(String datasourceClassname) {
        this.datasourceClassname = datasourceClassname;
    }

    public String getDatasourceUsername() {
        return datasourceUsername;
    }

    public void setDatasourceUsername(String datasourceUsername) {
        this.datasourceUsername = datasourceUsername;
    }

    public String getDatasourcePassword() {
        return datasourcePassword;
    }

    public void setDatasourcePassword(String datasourcePassword) {
        this.datasourcePassword = datasourcePassword;
    }

    public String getDatasourceFactory() {
        return datasourceFactory;
    }

    public void setDatasourceFactory(String datasourceFactory) {
        this.datasourceFactory = datasourceFactory;
    }

    /*
          public String getDatasourceXadataname() {
          return datasourceXadataname;
       }
       public void setDatasourceXadataname(String datasourceXadataname) {
          this.datasourceXadataname = datasourceXadataname;
       }
     */
    /*
       public String getDatasourceMincon() {
          return datasourceMincon;
       }
       public void setDatasourceMincon(String datasourceMincon) {
          this.datasourceMincon = datasourceMincon;
       }
     */
    /*
       public String getDatasourceMaxcon() {
          return datasourceMaxcon;
       }
       public void setDatasourceMaxcon(String datasourceMaxcon) {
          this.datasourceMaxcon = datasourceMaxcon;
       }
     */
    /*
       public String getDatasourceIsolationlevel() {
          return datasourceIsolationlevel;
       }
       public void setDatasourceIsolationlevel(String datasourceIsolationlevel) {
          this.datasourceIsolationlevel = datasourceIsolationlevel;
       }
     */
    public String getDatasourceMapper() {
        return datasourceMapper;
    }

    public void setDatasourceMapper(String datasourceMapper) {
        this.datasourceMapper = datasourceMapper;
    }

    public String getJdbcConnmaxage() {
        return jdbcConnmaxage;
    }

    public void setJdbcConnmaxage(String jdbcConnmaxage) {
        this.jdbcConnmaxage = jdbcConnmaxage;
    }

    public String getJdbcConnchecklevel() {
        return jdbcConnchecklevel;
    }

    public void setJdbcConnchecklevel(String jdbcConnchecklevel) {
        this.jdbcConnchecklevel = jdbcConnchecklevel;
    }

    public String getJdbcConnteststmt() {
        return jdbcConnteststmt;
    }

    public void setJdbcConnteststmt(String jdbcConnteststmt) {
        this.jdbcConnteststmt = jdbcConnteststmt;
    }

    /*
       public String getJdbcConnexcltimeout() {
          return jdbcConnexcltimeout;
       }
       public void setJdbcConnexcltimeout(String jdbcConnexcltimeout) {
          this.jdbcConnexcltimeout = jdbcConnexcltimeout;
       }
     */
    /*
       public String getJdbcConnmaxthreads() {
          return jdbcConnmaxthreads;
       }
       public void setJdbcConnmaxthreads(String jdbcConnmaxthreads) {
          this.jdbcConnmaxthreads = jdbcConnmaxthreads;
       }
     */

    public String getJdbcMinconpool() {
        return jdbcMinconpool;
    }

    public void setJdbcMinconpool(String jdbcMinconpool) {
        this.jdbcMinconpool = jdbcMinconpool;
    }

    public String getJdbcMaxconpool() {
        return jdbcMaxconpool;
    }

    public void setJdbcMaxconpool(String jdbcMaxconpool) {
        this.jdbcMaxconpool = jdbcMaxconpool;
    }

    /*
       public String getJdbcSleeptimepool() {
          return jdbcSleeptimepool;
       }
       public void setJdbcSleeptimepool(String jdbcSleeptimepool) {
          this.jdbcSleeptimepool = jdbcSleeptimepool;
       }
     */
    /*
       public boolean getJdbcGcpool() {
          return jdbcGcpool;
       }
       public void setJdbcGcpool(boolean jdbcGcpool) {
          this.jdbcGcpool = jdbcGcpool;
       }
     */
    /*
       public String getJdbcGenerationpool() {
          return jdbcGenerationpool;
       }
       public void setJdbcGenerationpool(String jdbcGenerationpool) {
          this.jdbcGenerationpool = jdbcGenerationpool;
       }
     */
    /*
       public String getJdbcDeadlockpool() {
          return jdbcDeadlockpool;
       }
       public void setJdbcDeadlockpool(String jdbcDeadlockpool) {
          this.jdbcDeadlockpool = jdbcDeadlockpool;
       }
     */
    /*
       public String getJdbcLoopwaitpool() {
          return jdbcLoopwaitpool;
       }
       public void setJdbcLoopwaitpool(String jdbcLoopwaitpool) {
          this.jdbcLoopwaitpool = jdbcLoopwaitpool;
       }
     */
    public java.util.List getBooleanValues() {
        return booleanValues;
    }

    public java.util.List getCheckingLevels() {
        return checkingLevels;
    }

    public boolean isCreate() {
        return create;
    }

    public void setCreate(boolean create) {
        this.create = create;
    }

}