/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: P_session.java,v 1.7 2003/07/25 13:19:12 legrasi Exp $
 * -------------------------------------------------------------------------- 
 */

package org.objectweb.jonas.jtests.clients.session;

import junit.framework.TestCase; 
import junit.framework.Test;
import junit.framework.TestSuite;
import junit.extensions.RepeatedTest;
import com.clarkware.junitperf.LoadTest;
import com.clarkware.junitperf.ThreadedTest;


public class P_session  extends TestCase {  

    public P_session (String name) {
        super(name);
    }
    public static Test suite() {
        TestSuite suite = new TestSuite();
        suite.addTest(new F_ClientViewSL("testEmpty"));
        suite.addTest(new F_ClientViewSL("testHomeLookup"));
        suite.addTest(new RepeatedTest(new F_ClientViewSL("testCreateRemove"),2));
        suite.addTest(new RepeatedTest(new F_ClientViewSF("testCreateRemove"),2));
        suite.addTest(new LoadTest (new RepeatedTest(new F_ClientViewSL("testBusinessMethod2"),2), 2));
        suite.addTest(new LoadTest (new RepeatedTest(new F_ClientViewSF("testBusinessMethod2"),2), 2));
        suite.addTest(new ThreadedTest(new F_ClientViewSL("testBusinessMethod3")));
        suite.addTest(new ThreadedTest(new F_ClientViewSF("testBusinessMethod3"))); 
        suite.addTest(new ThreadedTest(new F_ClientViewSL("testBusinessMethod3")));         
        suite.addTest(new F_ClientViewSL("testIsIdenticalOnBeans"));
        suite.addTest(new F_ClientViewSF("testIsIdenticalOnBeans"));
	return suite;
    }


    public static void main (String args[]) {
	junit.textui.TestRunner.run(suite());
    }
}
